#!/usr/bin/perl

# Script written by Roger Ngo and Todd H. Oakley, UCSB

my $input = $ARGV[0];
my $species = $ARGV[1];

my $output = "out.fasta";
my $output2 = "full.fasta";

open(INPUT, $input);
	open(OUTPUT, '>'."out.fasta");
	open(OUTPUT2, '>'."full.fasta");
			while(my $currLine = <INPUT>) {
				my @line = split(/\t/, $currLine);	
				# $line[0] = species, $line[1] = genefamily, $line[2] = genename, $line[3] = sequence	
				if($line[0] eq $species) {
					$line[2] =~ s/\|/_/g;
					print OUTPUT '>'.$line[2]."\n".$line[3];
				}
				$line[2] =~ s/\|/_/g;
				print OUTPUT2 '>'.$line[1].'|'.$line[0].'|'.$line[2]."\n".$line[3];
			}
	close(OUTPUT2);
	close(OUTPUT);
close(INPUT);
